#ifndef SLD_HH
# define SLD_HH

# include <cassert>
# include <ios>
# include <iostream>
# include <fstream>
# include <sstream>
# include <map>
# include <time.h>
# include <set>

# include "error.hh"
# include "daemon.hh"

typedef std::string string;
typedef std::stringstream sstream;
typedef std::ostream ostream;
typedef std::ifstream ifstream;

enum {
  ERR_OK = 0,
  ERR_USAGE = 1,
  ERR_BADPARAM = 2,
  ERR_FILE = 3,
  ERR_NET = 4,
  ERR_PROTO = 5,
  ERR_AUTH = 6,
  ERR_NOMEM = 41,
  ERR_UNKNOWN = 42
};

// -----------------------------------------------------------------------------
// Gonstant
// -----------------------------------------------------------------------------

static const string VERSION = "1";
static const int MAX_LINE_SIZE = 512;
static const int MAX_CONF_LINE_SIZE = 2048;
static const string RCV_DATA = "<< ";
static const string SND_DATA = ">> ";

/*!
** Get executable path
**
** @return string path
*/
string getbinpath();

/*!
** Handler for sig child
**
** @param int sig num
*/
void sigchild(int);

/*!
** Copy file src to dst
** Copy is unsafe !
**
** @param src file from copy
** @param dst file to copy
**
** @return bool success
*/
bool cp(const char *src, const char *dst);

#endif
